

magno-cli
===

- [About](#about)
- [Commands](#commands)
## About


> 前提： 需要本地安装nodejs, yarn以及python2。具体安装及环境变量配置请参考相应官网。
>
> 本地安装：`yarn run bootstrap` 安装magno命令之后，便可在命令行中执行`magno ui`打开高级页面或标准页面资产开发的工程。

## Commands

##### ui [options]
	start and open the magno-cli ui
##### create <app-name>
	create a new project powered by magno_assets_starter
##### add
	create a new package in the packages directory
##### storybook
	preview the components using storybook
##### build
	build all the packages
##### download
	download a widget from gallery
##### publish
	publish a widget to gallery
##### theme [options]
	preview or build the theme library, execute the command in the theme-chalk package
##### widget [options]
	preview or build the widget, execute the command in the widget package
##### vue-widget [options]
	preview or build the widget(Single File Component), execute the command in the widget(Single File Component) package
##### component [options]
	preview or build the component, execute the command in the component package


## vue开发widget

##### 1. 创建vue工程，单个工程打包为一个widget
  默认创建vue工程的package.json中默认脚本有serve、build、lint三个
```
"scripts": {
	"serve": "vue-cli-service serve",
	"build": "vue-cli-service build ",
	"lint": "vue-cli-service lint"
}
```

##### 2. 修改package.json中的脚本
  修改脚本build，添加脚本build:widget
```
"build": "vue-cli-service build --target lib --name TstApp ./src/widget.js",
"build:widget": "npm run build && magno buildvue -n TstApp -e TstApp -m ./dist -o TstApp.zip"
```

	magno buildvue是编译命令，示例代码中TstApp尽量保持统一。
	-n  是widget名称
	-e  是入口名字（vue 编译时暴露的全局变量），
	-m 是vue编译后的 dist 目录，
	-o  是输出的包名


##### 3. 添加编译入口文件
  以下是widget.js的内容，文件放在工程的src目录下 (与build脚本中的目录和文件名一致)
  init方法名及出入参不能修改；逻辑可修改，示例中编译的是App.vue，可修改为其他的vue组件。

```
/* eslint-disable */
import Vue from "vue";
import VueI18n from "vue-i18n";
import ElementUI from 'element-ui';

import App from "./App.vue";

Vue.config.productionTip = false;
Vue.use(VueI18n);
Vue.use(ElementUI);

export function init(
  elementOrSelector,
  context
) {
  const prefix = context.getWidgetBasePath();
  if (prefix) {
    __webpack_public_path__ = `${prefix}dist/`;
  }
  Vue.prototype.$magno = context || {};
  return new Vue({
    render: h => h(App)
  }).$mount(elementOrSelector);
}
```

##### 4. 组件开发
  组件的属性、事件、动作、依赖定义在package.json中，与dependencies平级添加magno节点。
```
  "magno": {
    "props": [
      {
        "config": [
          {
            "type": "text",
            "name": "prop1",
            "label": "Text Property",
            "value": ""
          },
          {
            "type": "connectorV2",
            "name": "demoConnector",
            "label": "Demo Connector",
            "model": "ViewModel",
            "value": ""
          }
        ]
      }
    ],
    "events": [
      {
        "name": "click",
        "displayName": "Click"
      }
    ],
    "actions": [
      {
        "name": "confirm",
        "displayName": "Confirm",
        "function": "confirm" // 在vue的methods中定义的方法名
      }
    ],
    "requires": [
      {
        "name": "global_Vue",
        "version": "100.8.2"
      }
    ]
  }
```


在Vue中使用this.$magno就相当于普通widget中的this，可调用相关Api。
```
获取组件属性： this.$magno.getProperties()
触发事件： this.$magno.triggerEvent('click')
获取桥接器实例：this.$magno.getConnectorInstanceByName('demoConnector')
```


##### 5. 编译widget

  依赖的公共库(如Vue、VueI18n等)不需要打包在组件中，通过平台的资源引入，在编译脚本中添加externals。


```
如使用vue脚手架创建的工程，则在根目录添加文件vue.config.js，参考如下，具体排除的库根据实际情况修改。
module.exports = {
  "configureWebpack": {
    "externals": {
      "vue": "Vue",
      "vue-i18n": "VueI18n",
      "vue-router": "VueRouter",
      "element-ui": "ElementUI"
    }
  }
}
```



 编译脚本调整完成后，执行yarn run build:widget编译出widget，需手工上传到平台。