module.exports = {
	entry: './index.js',
	output: {
		format: 'umd',
		moduleName: 'theme-chalk',
		minimize: true,
		fileNames: {
			css: 'assets/css/[name].css'
		}
	},
	css: {
		extract: true
	},
	configureWebpack: {
		resolve: {
			extensions: ['.mdx']
		},
		module: {
			rules: []
		}
	},
	chainWebpack (config) {
		config.module.rule('less')
			.oneOf('normal')
				.use('less-loader')
					.tap(options => Object.assign(options, {
						javascriptEnabled: true
					}))
					.end()
				.use('js-to-less')
					.loader('js-to-styles-var-loader');
		config.module.rule('scss')
			.oneOf('normal')
				.use('js-to-less')
					.loader('js-to-styles-var-loader');
	}
}