export default {
  data() {
    return {
      api: {},
      apiParams: null, // 考虑到卡片联动的参数没有通过initprops传入，我们在获取到接口参数的时候需要将格式化之后的参数存储起来
      apiTimer: null, // 计时器
    }
  },
  created() {

  },
  computed: {
  },
  methods: {
    //获取数据
    initChart(chatOption) {
       // 获取数据服务对象， 前提是用户需要props暴露options参数
      if (this.options && Array.isArray(this.options.apis) && this.options.apis.length > 0) {
        // 如果存在定时器先将定时器清除
        if (this.apiTimer !== null) {
          clearInterval(this.apiTimer)
        }
        const api = this.options.apis[0]
        this.api = api
        if (api.type === 'static') {
          this.getstaticData(chatOption)
        // this.chartData.rows = api.source
        } else if (api.type === 'api') {
          if (api.source.url) {
            let param = this.formatparmams()
            this.getAPIData(param,chatOption)
          }
        }
      }
    },
  //静态数据
  getstaticData(chatOption) {
      let data = this.api.source
      data = this.handleDataMap(data)
      let optionData = this.buildSeriesData(data)
      this.setSeriesData(optionData, chatOption)
  },
  // 通过api查询数据
  getAPIData(params,chatOption) {
    this.apiParams = params
    if (this.api && this.api.source && this.api.source.type && this.api.source.url) {
      // 先发一次接口，再调用定时器
      this.getNetWork(chatOption)
      if (this.api.duration) {
        this.apiTimer = setInterval(() => {
          this.getNetWork(chatOption)
        }, this.api.duration * 1000)
      }
    }
  },
  handleDataMap(data) {
    // 处理数据映射
    if (this.api.fields && this.api.fields.length > 0) {
      data = data.map(i => {
        let newData = {}
        this.api.fields.forEach(field => {
          newData[field.field] = i[field.mapField]
        })
        return newData
      })
    }
    return data
  },
  getNetWork(chatOption) {
    this.$service.network[this.api.source.type](this.api.source.url, this.api.source.type === 'post' ? this.apiParams : {
      params: this.apiParams
    }).then(response => {
      let data = response.data
      // 出参转换
      if (this.api.source.outCode) {
        try {
          data = new Function('dataset', this.api.source.outCode)(data) || data
        } catch (err) {

        }
      }
      if (!Array.isArray(data)) {
        return
      }
      data = this.handleDataMap(data)
      let optionData = this.buildSeriesData(data)
      this.setSeriesData(optionData, chatOption)
    })
  },
  //（echarts）构建图表Series数据, 可以根据实际情况进行覆盖此方法
  buildSeriesData(data = []){
     return []
  },
 // 设置图表series数据, 可以根据实际情况进行覆盖此方法
  setSeriesData(data, options){
    options.series[0].data = data
  },

  // 格式化入参，只有初始化时调用
  formatparmams() {
    let params = {}
    if (this.api.params) {
      this.api.params.map(item => {
        params[item.paramName] = item.paramDefaultValue
      })
    }

    if (this.api.source.inCode) {
      window.console.log("inCode",this.api.source.inCode)
      try {
        params = new Function('params', this.api.source.inCode)(params) || params
      } catch (err) {
        return params
      }
    }
    console.log("params",params)
    return params
  }
 }
}
