const service = require('./service')
const fse = require('fs-extra')

function convert(req, res) {
  let options = req.body || {}

  let result = service.convert(options)

  res.set('Content-Type', 'application/json; charset=utf-8')

  if (result && result.zipPath) {
    let stats = fse.statSync(result.zipPath)
    if (stats.isFile()) {
      const name = options.name || 'card'
      res.set({
        'Content-Type': 'application/octet-stream',
        'Content-Disposition': `attachment; filename=${name}.zip`,
        'Content-Length': stats.size
      })
      fse.createReadStream(result.zipPath).pipe(res)
    } else {
      res.status(500).json({ resCode: 1, resMessage: 'dit zip does not exist' })
    }
  } else {
    res.status(500).json({ resCode: 1, resMessage: result.error })
  }
}

module.exports = { convert }
