#!/usr/bin/env node
var _regeneratorRuntime=require("@babel/runtime/regenerator"),_asyncToGenerator=require("@babel/runtime/helpers/asyncToGenerator"),chalk=require("chalk"),minimist=require("minimist"),program=require("commander"),logUtils=require("../lib/util/logUtils");function camelize(e){return e.replace(/-(\w)/g,function(e,r){return r?r.toUpperCase():""})}function cleanArgs(n){var t={};return n.options.forEach(function(e){var r=camelize(e.long.replace(/^--/,""));"function"!=typeof n[r]&&void 0!==n[r]&&(t[r]=n[r])}),t}process.env.NODE_TLS_REJECT_UNAUTHORIZED="1",process.env.CURR_DIR=process.cwd(),program.version(require("../package").version).usage("<command> [options]"),program.command("create <app-name>").description("create a new project powered by magno_assets_starter").action(function(){var n=_asyncToGenerator(_regeneratorRuntime.mark(function e(r,n){var t;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return 1<minimist(process.argv.slice(3))._.length&&console.log(chalk.yellow("\n Info: You provided more than one argument. The first one will be used as the app's name, the rest are ignored.")),e.next=3,require("../lib/createApp")(process.env.CURR_DIR,r);case 3:0==(t=e.sent).resCode?logUtils.success(r+" has been created succesfully, execute the following command to initialize the project, and refer to README.md for more information:\r\n\r\n  cd "+r+" && yarn run bootstrap"):logUtils.error(t.resMessage);case 5:case"end":return e.stop()}},e)}));return function(e,r){return n.apply(this,arguments)}}()),program.command("add").description("create a new package in the packages directory").action(function(){require("../lib/addPackge")()}),program.command("storybook").description("preview the components using storybook").action(_asyncToGenerator(_regeneratorRuntime.mark(function e(){var r;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/runStorybook.js")();case 2:(r=e.sent)&&logUtils.error(r);case 4:case"end":return e.stop()}},e)}))),program.command("build").description("build all the packages").action(_asyncToGenerator(_regeneratorRuntime.mark(function e(){var r;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/buildPackage.js")();case 2:(r=e.sent)&&logUtils.error(r);case 4:case"end":return e.stop()}},e)}))),program.command("serve:card").description("serve card package").action(_asyncToGenerator(_regeneratorRuntime.mark(function e(){var r;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/serveCard.js")();case 2:(r=e.sent)&&logUtils.error(r);case 4:case"end":return e.stop()}},e)}))),program.command("build:card [cardName]").description("build card packages or one package").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/buildCardPackge")(r);case 2:(n=e.sent)&&logUtils.error(n);case 4:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("build:cube [cubeName]").description("build cube packages or one package").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/buildCubePackge")(r);case 2:(n=e.sent)&&logUtils.error(n);case 4:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("download").description("download a widget from gallery").action(function(){require("../lib/downloadWidget.js")()}),program.command("publish").description("publish a widget to gallery").action(_asyncToGenerator(_regeneratorRuntime.mark(function e(){return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,require("../lib/publishWidget.js")();case 2:process.exit();case 3:case"end":return e.stop()}},e)}))),program.command("theme").description("preview or build the theme library, execute the command in the theme-chalk package").option("-s, --serve","preview the theme library").option("-p, --prod","build the theme library").action(function(e){var r=cleanArgs(e);require("../lib/magnoTheme.js")(r)}),program.command("widget").description("preview or build the widget, execute the command in the widget package").option("-s, --serve","preview the widget").option("-p, --prod","build the widget").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n,t;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return n=cleanArgs(r),e.next=3,require("../lib/magnoWidget.js")(n);case 3:(t=e.sent)&&logUtils.error(t);case 5:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("vue-widget").description("preview or build the widget(Single File Component), execute the command in the widget(Single File Component) package").option("-p, --prod","build the widget").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n,t;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return n=cleanArgs(r),e.next=3,require("../lib/magnoVueWidget.js")(n);case 3:(t=e.sent)&&logUtils.error(t);case 5:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("component").description("preview or build the component, execute the command in the component package").option("-s, --serve","preview the component").option("-p, --prod","build the component").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n,t;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return n=cleanArgs(r),e.next=3,require("../lib/magnoComponent.js")(n);case 3:(t=e.sent)&&logUtils.error(t);case 5:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("buildvue").description("The bundler to build a widget package of magno for a UMD module").option("-n, --name <name>","the name of the widget name").option("-d, --description <description>","the description of the widget").option("-e, --entry <entry>","the entry name of the module").option("-m, --modulePath <modulePath>","the UMD module path").option("-o, --out <out>","the output path").action(function(){var r=_asyncToGenerator(_regeneratorRuntime.mark(function e(r){var n,t;return _regeneratorRuntime.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:return n=cleanArgs(r),e.next=3,require("../lib/buildVueWidget.js")(n);case 3:(t=e.sent)&&logUtils.error(t);case 5:case"end":return e.stop()}},e)}));return function(e){return r.apply(this,arguments)}}()),program.command("ui").description("start and open the magno-cli ui").option("-H, --host <host>","Host used for the UI server (default: localhost)").option("-p, --port <port>","Port used for the UI server (by default search for available port)").option("--quiet","Don't output starting messages").option("--headless","Don't open browser on start and output port").action(function(e){require("../lib/magnoUi")(cleanArgs(e))}),program.arguments("<command>").action(function(e){program.outputHelp(),console.log("  "+chalk.red("Unknown command ".concat(chalk.yellow(e),"."))),console.log()}),program.on("--help",function(){console.log(),console.log("  Run ".concat(chalk.cyan("magno <command> --help")," for detailed usage of given command.")),console.log()}),program.commands.forEach(function(e){return e.on("--help",function(){return console.log()})}),program.parse(process.argv),process.argv.slice(2).length||program.outputHelp();